﻿MontsKBIndicator = {}

--brothers_of_metal will not display numbers, still in code but not an option.  Will put back in if requested
-- Adding: FiddumsFamily, dpquake, KingthingsXander, KnightsQuest, VTCGoblinHand
-- Added edit option, not fully functional but close

-- 12/20/2013
-- Using "CENTER" instead of math to center text
-- fixed issue in GreaterThanFiftyText that incorrectly made changes on favor text and not prestige text if player wasn't prestige level 50
-- Revamped CenterText to use "CENTER"
-- Added HideKBText
-- Added ShowKBText which is used for moving text
-- Removed EditText function as that is handled by MKBI Setting UI.lua
-- Changed from setting text to empty string to using RebuildText to reset textfields for killing blows
-- Changed moving from a square box to also show the text.  Hides menu when displayed, shows menu when hidden.
-- Increased max Prestige Level to 90
-- Changed Saves to hide KB Text
-- Changed KBs to hide Save text
-- Changed Saves to only work on targets in combat
-- Added an Enable Saves check box and the saved varaible enable_saves
-- Changed Saves to only work on targets in Combat
-- Added a test functionality for testing KB settings (not saves currently)
-- Added an Up Time scrollbar with increments of 0.1
-- Changed size scrollbar to be in increments of 1 

-- 1/4/2014
-- Added function to sort fonts in the Font Menu (what a pain haha)
-- Added the fonts Most Wasted, Silent Hill E, Celexa, Face Your Fears, and Halo

--1/15/2014
-- Added ability for Saves to have own font, sizes, and colors
-- Changed saves to have their own location
-- Added tabs to configure KBs or Saves

-- 1/23/2014
-- Hopefully fixed issue with nil savenamexxxx variables.  They were missing in ResetToDefault()

mkbi_ui = UI.CreateContext("MontKB UI")
mkbi_textframe = UI.CreateFrame("Text","Main Text Frame",mkbi_ui)
local mkbi_nametext = UI.CreateFrame("Text","Name Text Frame",mkbi_ui)
local mkbi_xptext = UI.CreateFrame("Text","Experience Text Frame",mkbi_ui)
local mkbi_patext = UI.CreateFrame("Text","PA Experience Text Frame",mkbi_ui)
local mkbi_favor = UI.CreateFrame("Text","Favor Text Frame",mkbi_ui)
mkbi_prestige = UI.CreateFrame("Text","Prestige Text Frame",mkbi_ui)
mkbi_saveframe = UI.CreateFrame("Text","Save Main Text Frame",mkbi_ui)
mkbi_savename = UI.CreateFrame("Text","Save Name Text Frame",mkbi_ui)

--local mkbi_test = UI.CreateFrame("Text","Test Frame",mkbi_ui)

mkbi_playerid = nil
mkbi_starttime = nil
mkbi_moveable = false
local mkbi_maxlevel = false  -- Indicates if the player is level 60 and no longer acquiring XP
local mkbi_gtfifty = false   -- indicates the player is at least level 50 and should acquire PA XP
local mkbi_editing = false	-- Indicates that the player is editing the text

local mkbi_currxp = 0
local mkbi_currpa = 0
local mkbi_currfavor = 0
local mkbi_currprestige = 0
local mkbi_prevxp = 0
local mkbi_prevpa = 0
local mkbi_prevfavor = 0
local mkbi_prevprestige = 0

function MontsKBIndicator.Main(hEvent,a)
	if a ~= "MontsKBIndicator" then
		return
	end
	if not MKBISave then
		MKBISave = {
				x = 100,
				y = 100,
				font = "Fonts/Cas_antn.ttf",
				mainsize = 15,
				namesize = 35,
				xpsize = 17,
				pasize = 17,
				favsize = 17,
				pressize = 17,
				mainred = 1,
				maingreen = 1,
				mainblue = 0,
				namered = 1,
				namegreen = 0,
				nameblue = 0,
				xpred = 0.8,
				xpgreen = 0.8,
				xpblue = 0,
				pared = 0.2,
				pagreen = 1,
				pablue = 0.2,
				favred = 0.8,
				favgreen = 0,
				favblue = 0.8,
				presred = 0.2,
				presgreen = 0.2,
				presblue = 1,
				alpha = 1,
				uptime = 5
		}
	end
	if not MKBISave.specialmsg then
	    MKBISave.specialmsg = false
	end
	if not MKBISave.buttonx then
	    local mkbi_button_x_default = UIParent:GetWidth()/2
        local mkbi_button_y_default = UIParent:GetHeight()/2
	    MKBISave.buttonx = mkbi_button_x_default
	    MKBISave.buttony = mkbi_button_y_default
	end
	if not MKBISave.editx then
	    MKBISave.editx = 100
	    MKBISave.edity = 100
	end
	if not MKBISave.enable_saves then
	    MKBISave.enable_saves = true
	end
	if not MKBISave.savemainred then
		MKBISave.savemainred = 0
		MKBISave.savemaingreen = 0.7
		MKBISave.savemainblue = 0
		MKBISave.savemainsize = 15
		MKBISave.savealpha = 1
		MKBISave.savefont = "Fonts/Cas_antn.ttf"
	end
	if not MKBISave.savenamered then
		MKBISave.savenamered = 0.7
		MKBISave.savenamegreen = 0.7
		MKBISave.savenameblue = 0
		MKBISave.savenamesize = 35
	end
	if not MKBISave.savex then
		MKBISave.savex = 400
		MKBISave.savey = 400
	end
	MontsKBIndicator.Build()
	MontsKBIndicator.BuildSave()
	MontsKBIndicator.BuildEditUI()
	print("Mont's KB Indicator has loaded.")
end

-- Build the two frames using the saved/default variables
function MontsKBIndicator.Build()
	mkbi_textframe:SetFontSize(MKBISave.mainsize)
	mkbi_textframe:SetFontColor(MKBISave.mainred,MKBISave.maingreen,MKBISave.mainblue,MKBISave.alpha)
	mkbi_textframe:SetPoint("TOPLEFT",mkbi_ui,"TOPLEFT",MKBISave.x,MKBISave.y)
	mkbi_textframe:SetWordwrap(false)
	mkbi_textframe:SetLayer(1)
	mkbi_textframe:SetFont("MontsKBIndicator",MKBISave.font)
	mkbi_textframe:SetVisible(false)
	mkbi_textframe:SetText("You Have Killed")
	
	mkbi_nametext:SetFontSize(MKBISave.namesize)
	mkbi_nametext:SetFontColor(MKBISave.namered,MKBISave.namegreen,MKBISave.nameblue,MKBISave.alpha)
	mkbi_nametext:SetFont("MontsKBIndicator",MKBISave.font)
	--mkbi_nametext:SetPoint("TOPLEFT",mkbi_ui,"TOPLEFT",MKBISave.x,mkbi_textframe:GetBottom())
	MontsKBIndicator.CenterText(mkbi_nametext,mkbi_textframe)
	mkbi_nametext:SetLayer(1)
	mkbi_nametext:SetWordwrap(false)
	mkbi_nametext:SetVisible(false)
	mkbi_nametext:SetText("")
	
	mkbi_xptext:SetFontSize(MKBISave.xpsize)
	mkbi_xptext:SetFontColor(MKBISave.xpred,MKBISave.xpgreen,MKBISave.xpblue,MKBISave.alpha)
	mkbi_xptext:SetFont("MontsKBIndicator",MKBISave.font)
	--mkbi_xptext:SetPoint("TOPLEFT",mkbi_ui,"TOPLEFT",MKBISave.x,mkbi_nametext:GetBottom())
	MontsKBIndicator.CenterText(mkbi_xptext,mkbi_nametext)
	mkbi_xptext:SetLayer(1)
	mkbi_xptext:SetWordwrap(false)
	mkbi_xptext:SetVisible(false)
	mkbi_xptext:SetText("")
	
	mkbi_patext:SetFontSize(MKBISave.pasize)
	mkbi_patext:SetFontColor(MKBISave.pared,MKBISave.pagreen,MKBISave.pablue,MKBISave.alpha)
	mkbi_patext:SetFont("MontsKBIndicator",MKBISave.font)
	--mkbi_patext:SetPoint("TOPLEFT",mkbi_ui,"TOPLEFT",MKBISave.x,mkbi_xptext:GetBottom())
	MontsKBIndicator.CenterText(mkbi_patext,mkbi_xptext)
	mkbi_patext:SetLayer(1)
	mkbi_patext:SetWordwrap(false)
	mkbi_patext:SetVisible(false)
	mkbi_patext:SetText("")
	
	mkbi_favor:SetFontSize(MKBISave.favsize)
	mkbi_favor:SetFontColor(MKBISave.favred,MKBISave.favgreen,MKBISave.favblue,MKBISave.alpha)
	mkbi_favor:SetFont("MontsKBIndicator",MKBISave.font)
	--mkbi_favor:SetPoint("TOPLEFT",mkbi_ui,"TOPLEFT",MKBISave.x,mkbi_patext:GetBottom())
	MontsKBIndicator.CenterText(mkbi_favor,mkbi_patext)
	mkbi_favor:SetLayer(1)
	mkbi_favor:SetWordwrap(false)
	mkbi_favor:SetVisible(false)
	mkbi_favor:SetText("")
	
	mkbi_prestige:SetFontSize(MKBISave.pressize)
	mkbi_prestige:SetFontColor(MKBISave.presred,MKBISave.presgreen,MKBISave.presblue,MKBISave.alpha)
	mkbi_prestige:SetFont("MontsKBIndicator",MKBISave.font)
--	mkbi_prestige:SetPoint("TOPLEFT",mkbi_ui,"TOPLEFT",MKBISave.x,mkbi_favor:GetBottom())
    MontsKBIndicator.CenterText(mkbi_prestige,mkbi_favor)
	mkbi_prestige:SetLayer(1)
	mkbi_prestige:SetWordwrap(false)
	mkbi_prestige:SetVisible(false)
	mkbi_prestige:SetText("")
	
	-- mkbi_test:SetFontSize(35)
	-- mkbi_test:SetPoint("TOPLEFT",mkbi_ui,"TOPLEFT",100,MKBISave.y-100)
	-- mkbi_test:SetFont("MontsKBIndicator",MKBISave.font)
	-- mkbi_test:SetVisible(true)
	-- mkbi_test:SetText("This Is To Compare")
end

function MontsKBIndicator.RebuildText()
	mkbi_textframe:ClearAll()
	mkbi_nametext:ClearAll()
	mkbi_xptext:ClearAll()
	mkbi_patext:ClearAll()
	mkbi_favor:ClearAll()
	mkbi_prestige:ClearAll()
	
	MontsKBIndicator.Build()
end

-- Get the player's ID to use to only trigger events involving the player
function MontsKBIndicator.GetPlayerID(hEvent,mkbi_info)
	for id,whois in pairs(mkbi_info) do
		if whois == "player" then
			mkbi_playerid = id
			local mkbi_playerinfo = Inspect.Unit.Detail(id)
			--print(mkbi_playerinfo)
			if mkbi_playerinfo.level == 60 then
				mkbi_maxlevel = true
			end
			if mkbi_playerinfo.level >= 50 then
				mkbi_gtfifty = true
			end
			local mkbi_getxp = Inspect.Experience()
			mkbi_prevxp = mkbi_getxp.accumulated
			mkbi_currxp = mkbi_getxp.accumulated
			
			local mkbi_getpa = Inspect.Attunement.Progress()
			mkbi_prevpa = mkbi_getpa.accumulated
			mkbi_currpa = mkbi_getpa.accumulated
			
			local mkbi_getfavor = Inspect.Pvp.History()
			mkbi_prevfavor = mkbi_getfavor.favorLifetime
			mkbi_currfavor = mkbi_getfavor.favorLifetime
			
			local mkbi_getprestige = Inspect.Pvp.Prestige()
			mkbi_prevprestige = mkbi_getprestige.accumulated
			mkbi_currprestige = mkbi_getprestige.accumulated
			break
		end
	end
end

-- A killing blow has occurred.  Check to see if the player was the one that got the killing blow, and if it was then display
-- the killing blow text stuff.
function MontsKBIndicator.IDoneGotAKillingBlow(hEvent,kb_info)
	if kb_info then  -- Make sure a nil wasn't sent from the Event
		if kb_info.caster and kb_info.target then -- Make sure there are caster and target information to prevent errors
			if kb_info.caster ~= mkbi_playerid then -- Only continue if the caster was the player
				return
			end
			local mkbi_target = Inspect.Unit.Detail(kb_info.target)  -- Get target info
			if mkbi_target.player then  -- If target was a player it's go time
			    MontsKBIndicator.RebuildText()
			    -- Hide Save text
			    if mkbi_saveframe:GetVisible() then
			        mkbi_saveframe:SetVisible(false)
			        mkbi_savename:SetVisible(false)
			    end
				if MKBISave.specialmsg then
				    MontsKBIndicator.SetMessageToType()
				else
				    mkbi_textframe:SetText("You Have Killed")
                end
				mkbi_textframe:SetVisible(true)
				
				mkbi_nametext:SetText(mkbi_target.name)		-- Set the bottom text field to the Player's Name
				MontsKBIndicator.CenterText(mkbi_nametext,mkbi_textframe)
				mkbi_nametext:SetVisible(true)
				
				if not mkbi_maxlevel then  -- Is the player not the max level?
					if mkbi_gtfifty then  -- Is the player's level greater than 50?
						MontsKBIndicator.GreaterThanFiftyText()
					else
						MontsKBIndicator.LessThanFiftyText()
					end
				else
					MontsKBIndicator.MaxLevelText()
				end
				
				mkbi_starttime = Inspect.Time.Real()
			end
		end
	end
end

-- Player is level 60.  Display PA XP if player is not PA capped.  Display Favor.  Display Prestige if player is less than rank 80.
function MontsKBIndicator.MaxLevelText()
	mkbi_prestige:SetVisible(false) -- The Prestige Text Frame is not used since everything is shifted up one Text Frame to 
									--account for Max Level Players not needing XP
	if mkbi_currpa then
		local mkbi_diffpa = mkbi_currpa - mkbi_prevpa
		mkbi_xptext:SetText(tostring(mkbi_diffpa) .. " PA XP")
		MontsKBIndicator.CenterText(mkbi_xptext,mkbi_nametext)
		mkbi_xptext:SetFontColor(MKBISave.pared,MKBISave.pagreen,MKBISave.pablue,MKBISave.alpha)
		mkbi_xptext:SetVisible(true)
		
		local mkbi_difffavor = mkbi_currfavor - mkbi_prevfavor
		mkbi_patext:SetText(tostring(mkbi_difffavor) .. " Favor")
		MontsKBIndicator.CenterText(mkbi_patext,mkbi_xptext)
		mkbi_patext:SetFontColor(MKBISave.favred,MKBISave.favgreen,MKBISave.favblue,MKBISave.alpha)
		mkbi_patext:SetVisible(true)
		
		
		local mkbi_prank = Inspect.Pvp.Prestige()
		if mkbi_prank.rank == 90 then  -- Max rank players no longer receive Prestige CHANGE THIS WHEN MAX RANK IS INCREASED!!!!!!!!!!!!!!!!
			mkbi_favor:SetVisible(false)
		else
			local mkbi_diffprestige = mkbi_currprestige - mkbi_prevprestige
			mkbi_favor:SetText(tostring(mkbi_diffprestige) .. " Prestige")
			MontsKBIndicator.CenterText(mkbi_favor,mkbi_patext)
			mkbi_favor:SetFontColor(MKBISave.presred,MKBISave.presgreen,MKBISave.presblue,MKBISave.alpha)
			mkbi_favor:SetVisible(true)
		end
	else
		mkbi_prestige:SetVisible(false)
		mkbi_favor:SetVisible(false)
		local mkbi_difffavor = mkbi_currfavor - mkbi_prevfavor
		mkbi_xptext:SetText(tostring(mkbi_difffavor) .. " Favor")
		MontsKBIndicator.CenterText(mkbi_xptext,mkbi_nametext)
		mkbi_xptext:SetFontColor(MKBISave.favred,MKBISave.favgreen,MKBISave.favblue,MKBISave.alpha)
		mkbi_xptext:SetVisible(true)
		
		
		local mkbi_prank = Inspect.Pvp.Prestige()
		if mkbi_prank.rank == 90 then  -- Max rank players no longer receive Prestige CHANGE THIS WHEN MAX RANK IS INCREASED!!!!!!!!!!!!!!!!
			mkbi_patext:SetVisible(false)
		else
			local mkbi_diffprestige = mkbi_currprestige - mkbi_prevprestige
			mkbi_patext:SetText(tostring(mkbi_diffprestige) .. " Prestige")
			MontsKBIndicator.CenterText(mkbi_patext,mkbi_xptext)
			mkbi_patext:SetFontColor(MKBISave.presred,MKBISave.presgreen,MKBISave.presblue,MKBISave.alpha)
			mkbi_patext:SetVisible(true)
		end
	end
end

-- Player is less than level 50.  Show XP and Favor.
function MontsKBIndicator.LessThanFiftyText()
	-- Favor and Prestige text frames are not needed as low level players do not get Prestige and Favor is put into PA text frame as they do not receive PA XP either.
	mkbi_favor:SetVisible(false)
	mkbi_prestige:SetVisible(false)
	local mkbi_diffxp = mkbi_currxp - mkbi_prevxp
	mkbi_xptext:SetText(tostring(mkbi_diffxp) .. " XP")
	MontsKBIndicator.CenterText(mkbi_xptext,mkbi_nametext)
	mkbi_xptext:SetVisible(true)
	
	local mkbi_difffavor = mkbi_currfavor - mkbi_prevfavor
	mkbi_patext:SetText(tostring(mkbi_difffavor) .. " Favor")
	MontsKBIndicator.CenterText(mkbi_patext,mkbi_xptext)
	mkbi_patext:SetFontColor(MKBISave.favred,MKBISave.favgreen,MKBISave.favblue,MKBISave.alpha)
	mkbi_patext:SetVisible(true)
end

-- Player is greater than or equal to 50 but not yet 60.  Show XP, PA XP, Favor, and Prestige
function MontsKBIndicator.GreaterThanFiftyText()
	local mkbi_diffxp = mkbi_currxp - mkbi_prevxp
	mkbi_xptext:SetText(tostring(mkbi_diffxp) .. " XP")
	MontsKBIndicator.CenterText(mkbi_xptext,mkbi_nametext)
	mkbi_xptext:SetVisible(true)
	
	local mkbi_diffpa = mkbi_currpa - mkbi_prevpa
	mkbi_patext:SetText(tostring(mkbi_diffpa) .. " PA XP")
	MontsKBIndicator.CenterText(mkbi_patext,mkbi_xptext)
	mkbi_patext:SetVisible(true)
	
	local mkbi_difffavor = mkbi_currfavor - mkbi_prevfavor
	mkbi_favor:SetText(tostring(mkbi_difffavor) .. " Favor")
	MontsKBIndicator.CenterText(mkbi_favor,mkbi_patext)
	mkbi_favor:SetVisible(true)
	
	local mkbi_prank = Inspect.Pvp.Prestige()
	if mkbi_prank.rank == 50 then  -- Players cannot gain Prestige when Rank 50 and not level 60
		mkbi_prestige:SetVisible(false)
	else
		local mkbi_diffprestige = mkbi_currprestige - mkbi_prevprestige
		mkbi_prestige:SetText(tostring(mkbi_diffprestige) .. " Prestige")
		MontsKBIndicator.CenterText(mkbi_prestige,mkbi_favor)
		mkbi_prestige:SetVisible(true)
	end
end



-- Keeps the text up for a set amount of time
function MontsKBIndicator.UpTime(hEvent)
	local mkbi_currenttime = Inspect.Time.Real()
    if mkbi_starttime then
        if mkbi_textframe:GetVisible() then
            mkbi_currenttime = Inspect.Time.Real()
            -- Hide and reset all text frames if time is up
            if mkbi_currenttime >= (mkbi_starttime+MKBISave.uptime) then
                MontsKBIndicator.HideKBText()                
                mkbi_starttime = nil
                
                if mkbi_currently_testing then
                    mkbi_currently_testing = false
                    MontsKBIndicator.EditUIShow()
                end
            end
        end
    end
    
    if mkbi_save_startime then
		if mkbi_saveframe:GetVisible() then
			mkbi_currenttime = Inspect.Time.Real()
			if mkbi_currenttime >= (mkbi_save_startime+MKBISave.uptime) then
                mkbi_savename:SetVisible(false)
                mkbi_saveframe:SetVisible(false)
                mkbi_savename:SetText("") 
                mkbi_save_startime = nil
                
                if mkbi_currently_testing then
                    mkbi_currently_testing = false
                    MontsKBIndicator.EditUIShow()
                end
            end
		end
    end
end

function MontsKBIndicator.HideKBText()
    mkbi_textframe:SetVisible(false)
    mkbi_nametext:SetVisible(false)
    mkbi_nametext:SetPoint("TOPLEFT",mkbi_ui,"TOPLEFT",MKBISave.x,mkbi_textframe:GetBottom())
    mkbi_nametext:SetText("")
    
    mkbi_xptext:SetVisible(false)
    mkbi_xptext:SetPoint("TOPLEFT",mkbi_ui,"TOPLEFT",MKBISave.x,mkbi_nametext:GetBottom())
    mkbi_xptext:SetFontColor(MKBISave.xpred,MKBISave.xpgreen,MKBISave.xpblue,MKBISave.alpha)
    mkbi_xptext:SetText("")
    
    mkbi_patext:SetVisible(false)
    mkbi_patext:SetPoint("TOPLEFT",mkbi_ui,"TOPLEFT",MKBISave.x,mkbi_xptext:GetBottom())
    mkbi_patext:SetFontColor(MKBISave.pared,MKBISave.pagreen,MKBISave.pablue,MKBISave.alpha)
    mkbi_patext:SetText("")
    
    mkbi_favor:SetVisible(false)
    mkbi_favor:SetPoint("TOPLEFT",mkbi_ui,"TOPLEFT",MKBISave.x,mkbi_patext:GetBottom())
    mkbi_favor:SetFontColor(MKBISave.favred,MKBISave.favgreen,MKBISave.favblue,MKBISave.alpha)
    mkbi_favor:SetText("")
    
    mkbi_prestige:SetVisible(false)
    mkbi_prestige:SetPoint("TOPLEFT",mkbi_ui,"TOPLEFT",MKBISave.x,mkbi_favor:GetBottom())
    mkbi_prestige:SetFontColor(MKBISave.presred,MKBISave.presgreen,MKBISave.presblue,MKBISave.alpha)
    mkbi_prestige:SetText("")
end

function MontsKBIndicator.ShowKBText()
	MontsKBIndicator.RebuildText()
	
	mkbi_textframe:SetFont("MontsKBIndicator",MKBISave.font)
	mkbi_nametext:SetFont("MontsKBIndicator",MKBISave.font)
	mkbi_xptext:SetFont("MontsKBIndicator",MKBISave.font)
	mkbi_patext:SetFont("MontsKBIndicator",MKBISave.font)
	mkbi_favor:SetFont("MontsKBIndicator",MKBISave.font)
	mkbi_prestige:SetFont("MontsKBIndicator",MKBISave.font)
	
	mkbi_textframe:SetPoint("TOPLEFT",mkbi_ui,"TOPLEFT",MKBISave.x,MKBISave.y)
    mkbi_textframe:SetVisible(true)
    
    mkbi_nametext:SetText("Thatguy@Server")
    mkbi_nametext:SetVisible(true)
    MontsKBIndicator.CenterText(mkbi_nametext,mkbi_textframe)
    
    mkbi_xptext:SetText("123 XP")
    mkbi_xptext:SetFontColor(MKBISave.xpred,MKBISave.xpgreen,MKBISave.xpblue,MKBISave.alpha)
    MontsKBIndicator.CenterText(mkbi_xptext,mkbi_nametext)
    mkbi_xptext:SetVisible(true)
    
    mkbi_patext:SetVisible(true)
    MontsKBIndicator.CenterText(mkbi_patext,mkbi_xptext)
    mkbi_patext:SetText("456 PA XP")
    mkbi_patext:SetFontColor(MKBISave.pared,MKBISave.pagreen,MKBISave.pablue,MKBISave.alpha)
    
    mkbi_favor:SetVisible(true)
    MontsKBIndicator.CenterText(mkbi_favor,mkbi_patext)
    mkbi_favor:SetText("789 Favor")
    mkbi_favor:SetFontColor(MKBISave.favred,MKBISave.favgreen,MKBISave.favblue,MKBISave.alpha)
    
    mkbi_prestige:SetVisible(true)
    MontsKBIndicator.CenterText(mkbi_prestige,mkbi_favor)
    mkbi_prestige:SetText("0 Prestige")
    mkbi_prestige:SetFontColor(MKBISave.presred,MKBISave.presgreen,MKBISave.presblue,MKBISave.alpha)
end

-- Centers a text field underneath another text field (anchor)
function MontsKBIndicator.CenterText(mkbi_frame,mkbi_anchor)
    local mkbi_nameofframe = mkbi_frame:GetName()
  --  print(mkbi_nameofframe)
    if mkbi_nameofframe == "Name Text Frame" then
        -- Adjust to prevent overlap, for some reason it seems to be just this frame that will do it
        mkbi_frame:SetPoint("CENTER",mkbi_anchor,"CENTER",0,mkbi_anchor:GetHeight()+10)
    else
	    mkbi_frame:SetPoint("CENTER",mkbi_anchor,"CENTER",0,mkbi_anchor:GetHeight())
	end
end

function MontsKBIndicator.Experience(hEvent,mkbi_xp)
	if mkbi_xp then
		mkbi_prevxp = mkbi_currxp
		mkbi_currxp = mkbi_xp
	end
end

function MontsKBIndicator.PA(hEvent,mkbi_pa)
	if mkbi_pa then
		mkbi_prevpa = mkbi_currpa
		mkbi_currpa = mkbi_pa
	end
end

function MontsKBIndicator.Favor(hEvent,mkbi_favor)
	if mkbi_favor then
		mkbi_prevfavor = mkbi_currfavor
		mkbi_currfavor = mkbi_favor
	end
end

function MontsKBIndicator.Prestige(hEvent,mkbi_prestige)
	if mkbi_prestige then
		mkbi_prevprestige = mkbi_currprestige
		mkbi_currprestige = mkbi_prestige
	end
end


Command.Event.Attach(Event.Addon.Load.End,MontsKBIndicator.Main,"Addon Load")
Command.Event.Attach(Event.Combat.Death,MontsKBIndicator.IDoneGotAKillingBlow,"Look how big my e-peen is")
Command.Event.Attach(Event.Unit.Availability.Full,MontsKBIndicator.GetPlayerID,"Who Am I?")
Command.Event.Attach(Event.Experience.Accumulated,MontsKBIndicator.Experience,"I ain't 60 yet")
Command.Event.Attach(Event.Attunement.Progress.Accumulated,MontsKBIndicator.PA,"Attunement XP")
Command.Event.Attach(Event.Pvp.History.Favor,MontsKBIndicator.Favor,"I got me some Favor")
Command.Event.Attach(Event.Pvp.Prestige.Accumulated,MontsKBIndicator.Prestige,"I got me some Prestige")
Command.Event.Attach(Event.System.Update.Begin,MontsKBIndicator.UpTime,"Gotta have time to read it!")